#include	<Be.h>

void	help();
void	quit(char *s);

int main(int argc,char **argv)
{
	int	job=0;
	if((argc==3)&&(!strcmp(argv[1],"-dump")))job=1;
	if((argc==3)&&(!strcmp(argv[1],"-info")))job=2;
	if((argc==4)&&(!strcmp(argv[1],"-size")))job=3;

	if(job==0)help();

	BNode	n(argv[argc-1]);
	if(n.InitCheck())quit("not found");

	if(job==1){		//dump
		for(int i=0;;i++){
			char	name[B_ATTR_NAME_LENGTH];
			attr_info	info;
			if(n.GetNextAttrName(name)!=B_NO_ERROR)break;
			n.GetAttrInfo(name,&info);
			printf("i=%d : name=[%s] : type=%c%c%c%c : size=%06x\n",i,name,info.type>>24,info.type>>16,info.type>>8,info.type,info.size);
			uchar	*buf=new uchar[info.size];
			n.ReadAttr(name,info.type,0,buf,info.size);
			for(int j=0;j<info.size;j++){
				if((j%16)==0)printf("%04x :",j);
				printf(" %02x",buf[j]);
				if(((j%16)==15)||(j==info.size-1))printf("\n");
			}
			delete	buf;
		}
	}
	if(job==2){		//info
		for(int i=0;;i++){
			char	name[B_ATTR_NAME_LENGTH];
			attr_info	info;
			if(n.GetNextAttrName(name)!=B_NO_ERROR)break;
			n.GetAttrInfo(name,&info);
			uchar	*buf=new uchar[info.size];
			n.ReadAttr(name,info.type,0,buf,info.size);
			if(!strcmp(name,"_trk/windframe")){
				int	l,t,r,b;
				l=*((float*)(buf+0));
				t=*((float*)(buf+4));
				r=*((float*)(buf+8));
				b=*((float*)(buf+12));
				printf("window_frame : (%d,%d)-(%d,%d)\n",l,t,r,b);
			}
			if(!strcmp(name,"_trk/viewstate_le")){
//				printf("%c%c%c%c %c%c%c%c\n",buf[8],buf[9],buf[10],buf[11],buf[12],buf[13],buf[14],buf[15]);
				printf("bigicon_size=%d\n",buf[0x35]);
			}
			delete	buf;
		}
	}
	if(job==3){		//big-icon-size
		int	pt;
		sscanf(argv[2],"%d",&pt);
		if((pt<1)||(pt>255))quit("err: iconsize");
		for(int i=0;;i++){
			char	name[B_ATTR_NAME_LENGTH];
			attr_info	info;
			if(n.GetNextAttrName(name)!=B_NO_ERROR)break;
			n.GetAttrInfo(name,&info);
			uchar	*buf=new uchar[info.size];
			n.ReadAttr(name,info.type,0,buf,info.size);
			if(!strcmp(name,"_trk/viewstate_le")){
				printf("set bigicon_size=%d\n",pt);
				buf[0x35]=(uchar)pt;
				n.WriteAttr(name,info.type,0,buf,info.size);
			}
			delete	buf;
		}
	}

	return(0);
}


void help()
{
	printf("fldatr ver.0.00\n");
	printf("fldatr -dump dir_name\n");
	printf("fldatr -info dir_name\n");
	printf("fldatr -size big_icon_size dir_name\n");
	exit(0);
}

void quit(char *s)
{
	printf("%s\n",s);
	exit(1);
}
